//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2010 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

// asynchronous DNS facility

void* hostresolv_ReverseLookupRequest(const char* ip);
 /* Start a reverse lookup request of that ip (no matter if an ipv4 or ipv6 ip).
    Returns a request handle */

void* hostresolv_LookupRequest(const char* host, int ipv6);
 /* Start a normal lookup request of that host.
    Set ipv6 to 1 if you want an ipv6 (otherwise to 0).
    Returns a request handle */
 
int hostresolv_GetRequestStatus(void* handle);
 /* Get the current status of the request */
#define RESOLVSTATUS_PENDING 1
#define RESOLVSTATUS_SUCCESS 2
#define RESOLVSTATUS_FAILURE 3

const char* hostresolv_GetRequestResult(void* handle);
 /* Get the result of the lookup.
    Only use this if the request status is RESOLV_STATUS_SUCCESS! */
 
void hostresolv_FreeRequest(void* handle);
 /* Free the request and all associated data (handle will become invalid).
    NEVER use this if the request is still pending (will break horribly).
    This means, you can NOT cancel a request with this! */