//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef INET6_ADDRSTRLEN
#define INET6_ADDRSTRLEN 46 //needed for Microsoft Windows
#endif


#define IPV4LEN 16

#ifdef IPV6
	#define IPV6LEN INET6_ADDRSTRLEN
	#define IPMAXLEN (INET6_ADDRSTRLEN+2)
#else
	#define IPMAXLEN 16
#endif

extern int wantsend; /* Add up on this value if you plan to send stuff. so_SelectWait(..) will then check for
                        your sockets to be ready to write aswell.
			Otherwise, when this value is 0 again, so_SelectWait(...) will only stop when a socket
			is ready for reading.
			Suggested usage: Add 1 for all buffer blocks you want to send and substract 1 for every
			                 buffer block sent out */

void so_ManageSocketWithSelect(int socket);
int so_CreateSocket(int addToSelect, int iptype);
int so_MakeSocketListen(int socket, int port, int iptype, const char* bindip);
int so_ConnectSocketToIP(int socket, const char* ip); // FIXME
int so_SelectWait(int maximumsleeptime);
void so_CloseSocket(int socket);
int so_AcceptConnection(int socket, int iptype, char* writeip, int* writesocket);
int so_GetIPLen();
int so_CheckIp(const char* ip); // FIXME
int so_SelectSaysWrite(int sock);
int so_SelectSaysRead(int sock);
int so_SendOnSocket(int sock,const char* buffer,int buffsize);
int so_ReceiveData(int socket, char* buf, int len);
int so_Startup();
int so_ReverseResolveBlocking(const char* ip, char* hostbuf, int hostbuflen);
int so_ResolveBlocking(const char* host, int iptype, char* ipbuf, int ipbuflen);

#define IPTYPE_IPV4 1
#define IPTYPE_IPV6 2
