//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"
#include "timefuncs.h"
#include <time.h>

int time_offset = 0; //pretty important, can be changed to adjust the internally used time (time stamps used for registration times, nick changes, server to server, ...)

unsigned long long ts() {//get an internal timestamp, consisting of UTC+OFFSET
	return (time(NULL)+time_offset);
	tzset();
	time_t rawtime;
	struct tm *ptm;
	time(&rawtime);
	ptm = localtime(&rawtime);
	ptm->tm_sec += time_offset;
	ptm->tm_hour += timezone;
	return mktime(ptm);
}
unsigned long long shiftedtime(int hour) {//get timestamp of different timezone (used for presenting points in time to the users in some local timezone)
	return ts() + hour*60*60;
}
void appenddayofweek(int day, char* str) {
	switch (day) {
		case 0:
			strcat(str,"Sunday");break;
		case 1:
			strcat(str,"Monday");break;
		case 2:
			strcat(str,"Tuesday");break;
		case 3:
			strcat(str,"Wednesday");break;
		case 4:
			strcat(str,"Thursday");break;
		case 5:
			strcat(str,"Friday");break;
		case 6:
			strcat(str,"Saturday");break;
		case 7:
			strcat(str,"Sunday");break;
	}
}
void appendmonth(int month, char* str) {
	switch (month) {
		case 0:
			strcat(str,"January");break;
		case 1:
			strcat(str,"February");break;
		case 2:
			strcat(str,"March");break;
		case 3:
			strcat(str,"April");break;
		case 4:
			strcat(str,"May");break;
		case 5:
			strcat(str,"June");break;
		case 6:
			strcat(str,"July");break;
		case 7:
			strcat(str,"August");break;
		case 8:
			strcat(str,"September");break;
		case 9:
			strcat(str,"October");break;
		case 10:
			strcat(str,"November");break;
		case 11:
			strcat(str,"December");break;
	}
}

#define MAXTIMETWOYEARS 126144000
// long should cover    2147483647  or more
int parsetime(const char* timestr,long long* tg) {
	int r = 0;int k;
	if (strcasecmp(timestr,"0") == 0) {*tg = 0;return 0;}
	if (strlen(timestr) <= 1) {return -1;}
	*tg = 0;
	r = strlen(timestr)-1;
	char type;
	while (r >= 0) {
		if (timestr[r] != 'd' && timestr[r] != 'h' && timestr[r] != 'm' && timestr[r] != 's') {
			return -1;
		}
		type = timestr[r];
		r--;
		k = 1;
		while (r >= 0) {
			if (timestr[r] >= '0' && timestr[r] <= '9') {
				int val = (timestr[r]-'0');
				if (val > 300) {val = 300;}
				if (*tg < MAXTIMETWOYEARS) {
					if (type == 'd') {
						*tg += 24*60*60*val*k;
					}
					if (type == 'h') {
						*tg += 60*60*val*k;
					}
					if (type == 'm') {
						*tg += 60*val*k;
					}
					if (type == 's') {
						*tg += val*k;
					}
				}
			}else{
				if (k == 1) {return -1;}break;
			}
			k*=10;
			r--;
		}
		if (k == 1) {return -1;}
	}
	return 0;
}
void appenddigit(int digit, char* str) {
	if (digit < 10) {
		strcat(str,"0");
	}
	char tmp[10];
	sprintf(tmp,"%d",digit);
	strcat(str,tmp);
}
char tstr[300];
const char* time_GetTimeString(time_t vtime) {
	char tmp[30];
	struct tm* ctm;
	ctm = gmtime ((const time_t*)&time);
	strcpy(tstr,"");
	appenddayofweek(ctm->tm_wday,tstr);
	strcat(tstr," ");
	appendmonth(ctm->tm_mon,tstr);
	strcat(tstr," ");
	sprintf(tmp,"%d %d -- ",ctm->tm_mday,ctm->tm_year+1900);
	strcat(tstr,tmp);
	appenddigit(ctm->tm_hour,tstr);
	strcat(tstr,":");
	appenddigit(ctm->tm_min,tstr);
	strcat(tstr,":");
	appenddigit(ctm->tm_sec,tstr);
	strcat(tstr," +0:00");
	//Sunday April 5 2009 -- 13:33:16 -07:00
	return tstr;
}
