//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

#define SENDBUFFERBLOCKSIZE 513
int vsnd2(const char* oline,USER user) {
#ifdef ACTIVATEDEBUG
//	printf("<<[%d] %s\n",user,oline);
#endif
	if (strlen(oline) >= SENDBUFFERBLOCKSIZE) {return -1;}//too big; this is not allowed
	char line[SENDBUFFERBLOCKSIZE];
	strncpy(line,oline,SENDBUFFERBLOCKSIZE-1);line[SENDBUFFERBLOCKSIZE-1] = 0;
	if (strlen(line) <= 0) {return -1;}
	if (line[strlen(line)-1] != '\n') {
		if (strlen(line) < SENDBUFFERBLOCKSIZE - 2) {
			strcat(line,"\r\n");
		}else{
			return -1;
		}
	}
	if (udat(user)->hopcount > 0) {
		links_SendByUID(line,user);
		return 0;
	}
	if (udat(user)->fakeuser == 1) {
		trimright(line);
		FakeUsers_Send(user, line);
		return 0;
	}
	
	int r = 0;
	int k;
	while (r < USER_MAXSENDBUFFERS) {
		if (udat(user)->sendbuffer[r] == NULL) {
			break;
		}
		r += 1;
	}
	if (r == 0) {//nothing allocated yet; allocate
		udat(user)->sendbuffer[r] = malloc(SENDBUFFERBLOCKSIZE);
		strcpy(udat(user)->sendbuffer[r],line);
		udat(user)->sendblocks++;
		wantsend++;
		return 0;
	}else{
		if (strlen(udat(user)->sendbuffer[r - 1]) + strlen(line) < SENDBUFFERBLOCKSIZE) {
			strcat(udat(user)->sendbuffer[r - 1],line);
			return 0;
		}else{
			//we need a new buffer to cover all contents
			if (r >= USER_MAXSENDBUFFERS - 1) {
				if (udat(user)->mode_servicesbot == 1) {return 0;} //silently drop
				userQuit(user,USERQUIT_SENDQEXCEEDED);
				return -1;
			}//all pointers used; full!
			if (strlen(udat(user)->sendbuffer[r - 1]) >= SENDBUFFERBLOCKSIZE - 1) {
				udat(user)->sendbuffer[r] = malloc(SENDBUFFERBLOCKSIZE);
				strcpy(udat(user)->sendbuffer[r],line);
				udat(user)->sendblocks++;
				wantsend++;
				return 0;
			}else{
				k = SENDBUFFERBLOCKSIZE - (strlen(udat(user)->sendbuffer[r - 1]) + 1);
				stradd(udat(user)->sendbuffer[r - 1],line,SENDBUFFERBLOCKSIZE - 1);
				cut(line,k);
				udat(user)->sendbuffer[r] = malloc(SENDBUFFERBLOCKSIZE);
				strcpy(udat(user)->sendbuffer[r],line);
				udat(user)->sendblocks++;
				wantsend++;
				return 0;
			}
		}
	}
}
void scrollSendBuffer(USER user) {
	int r = 0;
	if (udat(user)->sendbuffer[0] != NULL) {free(udat(user)->sendbuffer[0]);}
	while (r < USER_MAXSENDBUFFERS - 1) {
		udat(user)->sendbuffer[r] = udat(user)->sendbuffer[r + 1];
		r += 1;
	}
	udat(user)->sendbuffer[USER_MAXSENDBUFFERS - 1] = NULL;
	udat(user)->sendblocks--;
	wantsend--;
}
void usnd(USER user,const char* line,...) {
	char vres[1000] = "";
	char tmp[51];
	const char* p;
	va_list ap;
	va_start(ap,line);
	unsigned int r = 0;
	while (r < strlen(line)) {
		if (line[r] == '%' && r < strlen(line) - 1) {
			if (line[r + 1] == 's') {
				p = va_arg(ap, char * );
				if (p != NULL) {
					stradd(vres,p,999);
				}
				r += 2;continue;
			}
			if (line[r + 1] == 'c') {
				if (strlen(vres) < 998) {
					vres[strlen(vres)+1] = 0;
					vres[strlen(vres)] = (char)va_arg(ap, int);
				}else{
					va_arg(ap, int);
				}
				r += 2;continue;
			}
			if (line[r + 1] == 'd') {
				snprintf(tmp,50,"%d",va_arg(ap, int));
				tmp[50] = 0;
				stradd(vres,tmp,999);
				r += 2;continue;
			}
			if (line[r + 1] == 'l' && r < strlen(line) - 2) {
				if (line[r + 2] == 'd') {
					snprintf(&tmp[0],50,"%ld",va_arg(ap, long));
					tmp[50] = 0;
					stradd(vres,tmp,999);
					r += 3;continue;
				}
				if (line[r + 2] == 'l' && r < strlen(line) - 3) {
					if (line[r + 3] == 'd') {
						#ifndef WIN
						snprintf(tmp,50,"%lld",va_arg(ap, long long));
						#else
						snprintf(tmp,50,"%I64d",va_arg(ap, long long));
						#endif
						tmp[50] = 0;
						stradd(vres,tmp,999);
						r += 4;continue;
					}
				}
			}
			if (line[r + 1] == 'f') {
				snprintf(tmp,50,"%f",va_arg(ap, double));
				tmp[50] = 0;
				stradd(vres,tmp,999);
				r += 2;continue;
			}
			if (line[r + 1] == '%') {
				stradd(vres,"%",999);
				r += 2;continue;
			}
		}
		if (strlen(vres) < 998) {
			vres[strlen(vres)+1] = 0;vres[strlen(vres)] = line[r];
		}
		r += 1;
	}
	va_end(ap);
	stradd(vres,"\r\n",999);vres[999] = 0;
	vres[530] = 0;//everything longer makes no real sense
	vsnd2(vres,user);
}
void vsnd(const char* oline, USER user) {vsnd2(oline,user);}

void usersend_Proceed() {
	usr_CycleInit();
	CHANNEL u = usr_DoCycle();
	while (u != NOUSER) {
		if (udat(u)->pleaseremove == 0 || udat(u)->sendbeforeremove == 1) {
			if (udat(u)->hopcount > 0) {u = usr_DoCycle();continue;}
			if (udat(u)->socket < 0) {u = usr_DoCycle();continue;}
			if (so_SelectSaysWrite(udat(u)->socket) != 0) {u = usr_DoCycle();continue;}
			if (udat(u)->sendbuffer[0] != NULL) {
				int k = so_SendOnSocket(udat(u)->socket,udat(u)->sendbuffer[0],strlen(udat(u)->sendbuffer[0]));
				if (k < 0) {u = usr_DoCycle();continue;} //just temporary problem
				if (k == 0) {//EOF
					so_CloseSocket(udat(u)->socket);
					udat(u)->socket = -1;
					userQuit(u,USERQUIT_EOF);
					u = usr_DoCycle();continue;
				}
				if ((unsigned int)k == strlen(udat(u)->sendbuffer[0])) {
					scrollSendBuffer(u);
				}else{
					cut(udat(u)->sendbuffer[0],k);
				}
			}
		}
		u = usr_DoCycle();
	}
}

